package cn.idaddy.open.demo.common;

import java.io.File;
import java.io.IOException;

import com.fasterxml.jackson.core.JsonEncoding;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.util.DefaultPrettyPrinter;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.databind.node.ObjectNode;

import cn.idaddy.open.demo.common.exceptions.ServiceFailure;

/**
 * UI状态存储器：简化的备忘录模式实现-Caretaker
 */
public class MementoCaretaker{
    // Save file
    ObjectMapper mapper = new ObjectMapper();
    {
      	mapper.enable(SerializationFeature.INDENT_OUTPUT);
    }

    File file=  new File("./data.json");
    public ObjectMapper mapper() {
        return mapper;
    }
    public ObjectNode load() {
		Log.info("load memento: "+file);

       	ObjectNode result=mapper.createObjectNode();
		if (file.exists()) {
			try {
				JsonNode readed = mapper.readTree(file);
				if(readed instanceof ObjectNode) {
					result = (ObjectNode) readed;
				}else {
					save(result);
				}
			} catch (IOException e) {
				save(result);
			}
		}    	     
		return result;
    }
    public void save(ObjectNode memento) {
		Log.info("save memento: "+file);

		try(JsonGenerator jgen = mapper.getFactory().createGenerator(file, JsonEncoding.UTF8);){
			jgen.setPrettyPrinter(new DefaultPrettyPrinter());

	         mapper.writeTree(jgen,memento);
		} catch (IOException e) {
			throw new ServiceFailure("file open error:"+file,e);
		}
    }
}