package cn.idaddy.open.demo.common.ui;

import java.io.PrintWriter;
import java.io.StringWriter;

import javafx.application.Platform;
import javafx.scene.control.ButtonType;
import javafx.scene.control.Dialog;
import javafx.scene.control.DialogPane;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Priority;
import javafx.stage.Modality;

/**
 * Created by chenpeng on 29/06/2017.
 */
public class Dialogs {

    public  static void showError(Throwable error) {
        Platform.runLater(() -> {
            Dialog<ButtonType> dialog = new Dialog<>();

            dialog.setTitle("Error");

            final DialogPane dialogPane = dialog.getDialogPane();
            dialogPane.setContentText("Details of the problem:");
            dialogPane.getButtonTypes().addAll(ButtonType.OK);
            dialogPane.setContentText(error.getMessage());
            dialog.initModality(Modality.APPLICATION_MODAL);

            Label label = new Label("Exception stacktrace:");
            StringWriter sw = new StringWriter();
            PrintWriter pw = new PrintWriter(sw);
            error.printStackTrace(pw);
            pw.close();

            TextArea textArea = new TextArea(sw.toString());
            textArea.setEditable(false);
            textArea.setWrapText(true);

            textArea.setMaxWidth(Double.MAX_VALUE);
            textArea.setMaxHeight(Double.MAX_VALUE);
            GridPane.setVgrow(textArea, Priority.ALWAYS);
            GridPane.setHgrow(textArea, Priority.ALWAYS);

            GridPane root = new GridPane();
            root.setVisible(false);
            root.setMaxWidth(Double.MAX_VALUE);
            root.add(label, 0, 0);
            root.add(textArea, 0, 1);
            dialogPane.setExpandableContent(root);
            dialog.showAndWait()
                    .filter(response -> response == ButtonType.OK)
                    .ifPresent(response -> System.out.println("The exception was approved"));
        });


    }

    public  static void showOk(String msg) {
        Platform.runLater(() -> {
            Dialog<ButtonType> dialog = new Dialog<>();

            dialog.setTitle("Ok");

            final DialogPane dialogPane = dialog.getDialogPane();
            dialogPane.setContentText("Details of the problem:");
            dialogPane.getButtonTypes().addAll(ButtonType.OK);
            dialogPane.setContentText(msg);
            dialog.initModality(Modality.APPLICATION_MODAL);
            dialog.showAndWait();
        });


    }

}
