package cn.idaddy.open.demo.common.ui;

import javafx.concurrent.Task;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.control.ProgressIndicator;
import javafx.scene.layout.Region;
import javafx.scene.layout.StackPane;

/**
 * Created by chenpeng on 29/06/2017.
 */
public class Progressable<TContent extends Node> {
    ProgressIndicator progressIndicator = new ProgressIndicator();
    {
        progressIndicator.setMaxSize(50, 50);
        progressIndicator.setVisible(false);
    }

    StackPane stack = new StackPane();
    Region veil = new Region();
    private TContent content;
    {
        veil.setStyle("-fx-background-color: rgba(0, 0, 0, 0.4)");
        veil.setVisible(false);
    }

    public Progressable(TContent content) {
        this.content=content;
        stack.getChildren().addAll(content,veil,progressIndicator);

    }

    public TContent getContent() {
        return content;
    }
    public Parent getWarpedContent() {
        return stack;
    }

    public <T> void run(Task<T> task) {
        progressIndicator.progressProperty().bind(task.progressProperty());
        veil.visibleProperty().bind(task.runningProperty());
        progressIndicator.visibleProperty().bind(task.runningProperty());
        new Thread(task).start();
    }
}