package cn.idaddy.open.demo;

import static org.junit.Assert.assertEquals;

import java.time.Clock;
import java.time.Instant;
import java.time.ZoneId;

import org.junit.Test;

import cn.idaddy.open.demo.service.AppSign;

public class TestSign {
	/*
	 * 和文档中的bash算法一致 
	 APP_ID=my-app-id-test00001
     APP_SECRET=my-app-secret-test00001
     TIMESTAMP=1498521600
     SIGNATURE=$(echo -n "${APP_ID}${APP_SECRET}${TIMESTAMP}" | openssl dgst -sha1 -hex )
     echo $SIGNATURE
     ------------------     
     9d7fd7c043087cd68e686f72a99099fd1ee86514
	 */
	@Test
	public void 固化签名算法() {
		AppSign s = AppSign.sign("my-app-id-test00001", "my-app-secret-test00001",Clock.fixed(Instant.parse("2017-06-27T00:00:00Z"), ZoneId.of("Asia/Shanghai")));
        System.out.println(s);
		assertEquals("9d7fd7c043087cd68e686f72a99099fd1ee86514", s.getSignature());
		              
		assertEquals(1498521600, s.getTimestamp());
	}
}
